
// Dlg.cpp : implementation file
//

#include "stdafx.h"
#include "EEROM.h"
#include "Dlg.h"
#include "afxdialogex.h"
#include "Transfer.h"

//#include <usbiodef.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// device description (must match)
const char *pszDevDesc = "EEROM512K";
// serial number prefix (must match)
const char *pszSPrefix = "EEROM";
// serial number size (must match)
const int nSerialSize = 8;

// FTD2XX driver interface GUID
static const GUID FTDI_D2XX_GUID = {0x219d0508, 0x57a8, 0x4ff5, {0x97, 0xa1, 0xbd, 0x86, 0x58, 0x7c, 0x6c, 0x7e}};
static const GUID FTDI_VCP_GUID  = {0x86e0d1e0, 0x8089, 0x11d0, {0x9c, 0xe4, 0x08, 0x00, 0x3e, 0x30, 0x1f, 0x73}};
// Computer Device Class: this is used to get the tree contrl root icon
static const GUID GUID_DEVCLASS_COMPUTER = {0x4D36E966, 0xE325, 0x11CE, {0xBF, 0xC1, 0x08, 0x00, 0x2B, 0xE1, 0x03, 0x18}};
static const GUID GUID_USB_WMI_STD_DATA  = {0x4E623B20, 0xCB14, 0x11D1, {0xB3, 0x31, 0x00, 0xA0, 0xC9, 0x59, 0xBB, 0xD2}}; 

// CAboutDlg dialog used for App About

class CAboutDlg : public CDialogEx
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialogEx(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialogEx)
END_MESSAGE_MAP()

// CTgtDlg dialog
class CTgtDlg : public CDialogEx
{
	DECLARE_DYNAMIC(CTgtDlg)

public:
	CTgtDlg(CWnd* pParent = NULL);   // standard constructor
	virtual ~CTgtDlg();

// Dialog Data
	enum { IDD = IDD_DIALOG1 };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

	DECLARE_MESSAGE_MAP()
public:
	CString m_strName;
};

IMPLEMENT_DYNAMIC(CTgtDlg, CDialogEx)

CTgtDlg::CTgtDlg(CWnd* pParent /*=NULL*/)
	: CDialogEx(CTgtDlg::IDD, pParent)
	, m_strName(_T(""))
{

}

CTgtDlg::~CTgtDlg()
{
}

void CTgtDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_EDIT1, m_strName);
}


BEGIN_MESSAGE_MAP(CTgtDlg, CDialogEx)
END_MESSAGE_MAP()


// CDlg dialog
CDlg::CDlg(CWnd* pParent /*=NULL*/)
	: CDialogEx(CDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_hDevNotify1 = NULL;
	m_hDevNotify2 = NULL;
	m_pTransfer = NULL;
	// clear devices array
	m_dwCount = 0;
	DWORD k;
	for (k = 0; k < MAX_EEROM_DEV; k++)
		m_gpDevice[k] = NULL;
}

void CDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_DEV_TREE, m_DevTree);
}

BEGIN_MESSAGE_MAP(CDlg, CDialogEx)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_DEVICECHANGE()
	ON_MESSAGE(WM_FTDEVICE, OnFTDevice)
	ON_NOTIFY(NM_RCLICK, IDC_DEV_TREE, &CDlg::OnRclickDevTree)
	ON_MESSAGE(WM_INITDEVICES, OnInitDevices)
END_MESSAGE_MAP()


// CDlg message handlers

BOOL CDlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	// register notification for detect plug/unplug of FTDI UM245R usb device
	DEV_BROADCAST_DEVICEINTERFACE NotificationFilter;
	ZeroMemory(&NotificationFilter, sizeof(NotificationFilter));
	NotificationFilter.dbcc_size = sizeof(DEV_BROADCAST_DEVICEINTERFACE);
	NotificationFilter.dbcc_devicetype = DBT_DEVTYP_DEVICEINTERFACE;
	NotificationFilter.dbcc_classguid = FTDI_D2XX_GUID;
	m_hDevNotify1 = RegisterDeviceNotification(GetSafeHwnd(), &NotificationFilter, DEVICE_NOTIFY_WINDOW_HANDLE);
	if(!m_hDevNotify1)
	{
		AfxMessageBox(CString("Can't register device notification (FTDI_D2XX_GUID): ") + _com_error(GetLastError()).ErrorMessage(), MB_ICONEXCLAMATION);
		return FALSE;
	}

	NotificationFilter.dbcc_classguid = FTDI_VCP_GUID;
	m_hDevNotify2 = RegisterDeviceNotification(GetSafeHwnd(), &NotificationFilter, DEVICE_NOTIFY_WINDOW_HANDLE);
	if(!m_hDevNotify2)
	{
		AfxMessageBox(CString("Can't register device notification (FTDI_VCP_GUID): ") + _com_error(GetLastError()).ErrorMessage(), MB_ICONEXCLAMATION);
		return FALSE;
	}

	PostMessage(WM_INITDEVICES, 0, 0);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialogEx::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialogEx::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

LRESULT CDlg::OnInitDevices(WPARAM wParam, LPARAM lParam)
{
	// devices's tree setup

	EnumDevices();
	
	DWORD k;
	for (k = 0; k < m_dwEnumCount; k++)
	{
		AddDevice(k);
	}

	return 0;
}

// devices enumeration on temp. array
BOOL CDlg::EnumDevices()
{
	FT_DEVICE_LIST_INFO_NODE *pgDev;
	FT_STATUS ftStatus;
	DWORD dwNumDevs, k;

	// clear temp. devices array
	m_dwEnumCount = 0;
	m_dwEnumAll;

	// create the device information list
	ftStatus = FT_CreateDeviceInfoList(&dwNumDevs);
	if (ftStatus != FT_OK)
	{
		char szBuf[128];
		sprintf_s(szBuf, "%s (error %d)", "FT_CreateDeviceInfoList() failed.", ftStatus);
		MessageBox(szBuf, "Error", MB_ICONEXCLAMATION);
		return FALSE;
	}

	if (dwNumDevs == 0)
		return FALSE;

	// allocate storage for array
	pgDev = new FT_DEVICE_LIST_INFO_NODE[dwNumDevs + 1];
	ftStatus = FT_GetDeviceInfoList(pgDev, &dwNumDevs);
	if (ftStatus != FT_OK)
	{
		char szBuf[128];
		delete[] pgDev;
		sprintf_s(szBuf, "%s (error %d)", "FT_GetDeviceInfoList() failed.", ftStatus);
		MessageBox(szBuf, "Error", MB_ICONEXCLAMATION);
		return FALSE;
	}

	CString szSerial, szTmp;
	m_dwEnumAll = dwNumDevs;
	for (k = 0; k < dwNumDevs; k++)
	{
		if (m_dwEnumCount >= MAX_EEROM_DEV)
			break;

		if (lstrcmp(pgDev[k].Description, pszDevDesc) == 0)
		{
			// handle just the right devices
			szSerial = pgDev[k].SerialNumber;
			if (szSerial.GetLength() != nSerialSize)
				continue; // not EEROM512K device
			// serial number is in the form EEROMXXX
			szTmp = szSerial.Left(lstrlen(pszSPrefix));
			if (szTmp.Compare(pszSPrefix) != 0)
				continue;
			szTmp = szSerial.Mid(lstrlen(pszSPrefix));
			// check for digit
			if (szTmp.SpanIncluding("0123456789") != szTmp)
				continue;

			m_gEnumDev[m_dwEnumCount].dwFlags = pgDev[k].Flags;
			m_gEnumDev[m_dwEnumCount].szSerial = szSerial;
			m_gEnumDev[m_dwEnumCount].ftHandle = pgDev[k].ftHandle;
			m_dwEnumCount++;
		}
	}

	delete[] pgDev;

	return TRUE;
}

BOOL CDlg::DestroyWindow()
{
	// TODO: Add your specialized code here and/or call the base class
	if (m_hDevNotify1)
	{
		UnregisterDeviceNotification(m_hDevNotify1);
		m_hDevNotify1 = NULL;
	}
	if (m_hDevNotify2)
	{
		UnregisterDeviceNotification(m_hDevNotify2);
		m_hDevNotify2 = NULL;
	}

	FT_HANDLE ftHandle;
	TDEVICE *p;
	DWORD k;

	for (k = 0; k < m_dwCount; k++)
	{
		p = m_gpDevice[k];
		ftHandle = p->ftHandle;
		if (ftHandle != NULL)
			FT_Close(ftHandle);
	}
	return CDialogEx::DestroyWindow();
}

BOOL CDlg::OnDeviceChange(UINT EventType, DWORD dwData)
{
	PDEV_BROADCAST_HDR lpdb = (PDEV_BROADCAST_HDR)dwData;
	PDEV_BROADCAST_DEVICEINTERFACE lpdev = (PDEV_BROADCAST_DEVICEINTERFACE)dwData;
	if ((EventType ==  DBT_DEVICEARRIVAL) || (EventType == DBT_DEVICEREMOVECOMPLETE))
	{
		const char *pszStr1  = "USB#VID_0403&PID_6001#";
		const char *pszStr2  = "FTDIBUS#VID_0403+PID_6001+";
		int n, n1, n2;
		// "USB#VID_0403&PID_6001#BROKEN#{219d0508-57a8-4ff5-97a1-bd86587c6c7e}"
		// "FTDIBUS#VID_0403+PID_6001+BROKENA#0000#{86e0d1e0-8089-11d0-9ce4-08003e301f73}"
		// quando si lancia: se non connesso al plug entrambe le stringhe, plug-out entrambe in senso invertito
		// HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Control\DeviceClasses

		if (lpdb->dbch_devicetype == DBT_DEVTYP_DEVICEINTERFACE)
		{
			if (lstrlen(lpdev->dbcc_name) < 5)
				return TRUE;
			CString szTmp, szSerial;
			szTmp = lpdev->dbcc_name + 4;
			n = szTmp.ReverseFind('#');
			if (n == -1)
				return TRUE;
			szTmp.Truncate(n);
			n1 = lstrlen(pszStr1);
			n2 = lstrlen(pszStr2);
			if (_strnicmp(szTmp, pszStr1, n1) == 0)
				szSerial = szTmp.Mid(n1);
			else if (_strnicmp(szTmp, pszStr2, n2) == 0)
			{
				n = szTmp.ReverseFind('#');
				if ((n == -1) || (n < 2))
					return TRUE;
				szTmp.Truncate(n - 1); // remove char 'A' after serial
				szSerial = szTmp.Mid(n2);
			}
			else
				return TRUE; // not a UM245R device
		
			if (szSerial.GetLength() != nSerialSize)
				return TRUE; // not EEROM512K device

			// serial number is in the form EEROMXXX
			szTmp = szSerial.Left(lstrlen(pszSPrefix));
			if (szTmp.Compare(pszSPrefix) != 0)
				return TRUE;
			szTmp = szSerial.Mid(lstrlen(pszSPrefix));
			// check for digit
			if (szTmp.SpanIncluding("0123456789") != szTmp)
				return TRUE;
	
			WPARAM wParam = FTDEVICE_REMOVE;
			if (EventType ==  DBT_DEVICEARRIVAL)
				wParam = FTDEVICE_ADD;
			LPSTR psz = _strdup(szSerial);
			PostMessage(WM_FTDEVICE, wParam, LPARAM(psz));
			
			//return TRUE;

			/*
			BOOL b = EnumDevices();
			DWORD dwIndex;
			if ((EventType ==  DBT_DEVICEARRIVAL) && (m_dwEnumCount > 0))
			{
				if (m_dwCount == 0)
					dwIndex = 0;
				else
					dwIndex = SearchPlugged();
				if (dwIndex != (DWORD)(-1))
					AddDevice(dwIndex);
				return TRUE;
			}
			else if ((EventType ==  DBT_DEVICEREMOVECOMPLETE) && (m_dwCount > 0))
			{
				if (m_dwCount == (m_dwEnumCount + 1))
				{
					dwIndex = SearchUnplugged();
					if (dwIndex != (DWORD)(-1))
						RemoveDevice(dwIndex);
				}
				return TRUE;
			}
			*/
			/*
			// check is really a dock/undock of the UM245R device
			if (strncmp(szDevId, pDev1, strlen(pDev1)) == 0)
				n = 0; // ok: str1 kind
			else if (strncmp(szDevId, pDev2, strlen(pDev2)) == 0)
				n = 1; // ok: str2 kind
			else
				n = -1; // not a UM245R device

			// ignore first step when dock
			if (n == 1)
			{
				// this is the second step of docking or undocking step
				idx = szDevId.Find('\\');
				ASSERT(idx != -1);
				CString szLeft = szDevId.Mid(idx + 1);
				idx = szLeft.Find('\\');
				ASSERT(idx != -1);
				CString szSer = szLeft.Left(idx);
				idx = szSer.ReverseFind('+');
				ASSERT(idx != -1);
				szSer = szSer.Mid(idx + 1);
				// skip final 'A' at the end
				int m = szSer.GetLength() - 1;
				if (szSer[m] == 'A')
					szSer = szSer.Left(m);
				//m_szDevId = CString(pDev2) + '+' + szSer;
				//m_szSer = szSer;
			}
			*/
		}
	}

	return TRUE;
}

LRESULT CDlg::OnFTDevice(WPARAM wParam, LPARAM lParam)
{
	//Sleep(2000);
	LPSTR pszSerial = (LPSTR)(lParam);

	//BOOL b = EnumDevices();
	DWORD dwIndex = SearchDevice(pszSerial);

	if (wParam ==  FTDEVICE_ADD)
	{
		// device must not be already connected
		if (dwIndex == (DWORD)(-1))
		{
			// loop to enum devices (give time to Windows for enumereate...)
			while (1)
			{
				EnumDevices();
				dwIndex = SearchEnumeratedDevice(pszSerial);
				if (dwIndex != (DWORD)(-1))
				{
					AddDevice(dwIndex);
					break;
				}
				Sleep(100);

				/*
				if (m_dwEnumCount == 0)
				{
					// not ready?
					Sleep(100);
					continue;
				}
				if (m_dwCount == 0)
					dwIndex = 0;
				else
					dwIndex = SearchPlugged();

				if (dwIndex != (DWORD)(-1))
					AddDevice(dwIndex);
				break;
				*/
			}
		}
	}
	else if ((wParam ==  FTDEVICE_REMOVE) && (m_dwCount > 0))
	{
		// device must be already connected
		if (dwIndex != (DWORD)(-1))
		{
			EnumDevices();
			RemoveDevice(dwIndex);
			/*
			if (m_dwCount == 1)
			{
				// remove the only one device 
				EnumDevices();
				RemoveDevice(dwIndex);
			}
			else
			{
				// loop to enum devices (give time to Windows for enumerate...)
				while (1)
				{
					EnumDevices();
					if (m_dwEnumCount == 0)
					{
						// not ready?
						Sleep(100);
						continue;
					}
					if (SearchUnplugged() == dwIndex)
					{
						if (m_dwCount == (m_dwEnumCount + 1))
							RemoveDevice(dwIndex);
					}
					break;
				}
			}
			*/
		}
	}

	free(pszSerial);

	return 0;
}

// search device in connected devices list that match serial number
DWORD CDlg::SearchDevice(LPCSTR pszSerial)
{
	DWORD k, dwRes = (DWORD)(-1);
	TDEVICE *p;

	if (m_dwCount == 0)
		return dwRes; // nothing

	for (k = 0; k < m_dwCount; k++)
	{
		p = m_gpDevice[k];
		if (p->szSerial.Compare(pszSerial) == 0)
		{
			dwRes = k; // found
			break;
		}
	}

	return dwRes;
}

// search device in enumerated devices list that match serial number
DWORD CDlg::SearchEnumeratedDevice(LPCSTR pszSerial)
{
	DWORD k, dwRes = (DWORD)(-1);

	if (m_dwEnumCount == 0)
		return dwRes; // nothing

	for (k = 0; k < m_dwEnumCount; k++)
	{
		if (m_gEnumDev[k].szSerial.Compare(pszSerial) == 0)
		{
			dwRes = k; // found
			break;
		}
	}

	return dwRes;
}

BOOL CDlg::AddDevice(DWORD dwIndex)
{
	TDEVICE *p;
	p = new TDEVICE;

	p->dwFlags = m_gEnumDev[dwIndex].dwFlags;
	p->ftHandle = m_gEnumDev[dwIndex].ftHandle;
	p->szSerial = m_gEnumDev[dwIndex].szSerial;
	p->bReady = FALSE;
	m_gpDevice[m_dwCount] = p;

	CApp* pApp = (CApp*)AfxGetApp();
	CString szIniFile = pApp->m_szIniFile;
	// configuration under [serial] section
	UINT nMemSize = ::GetPrivateProfileInt(p->szSerial, MEM_SIZE_SECT, MAX_MEM_SIZE, szIniFile);
	if ((nMemSize < 0) || (nMemSize > MAX_MEM_SIZE))
	{
		nMemSize = MAX_MEM_SIZE;
		::WritePrivateProfileString(p->szSerial, MEM_SIZE_SECT, MAX_MEM_SIZE_S, szIniFile);
	}
	char szFileName[MAX_PATH];
	DWORD dw = ::GetPrivateProfileString(p->szSerial, FILE_NAME_SECT, "", szFileName, MAX_PATH, szIniFile);
	char szTgtName[MAX_PATH];
	dw = ::GetPrivateProfileString(p->szSerial, TGT_NAME_SECT, "", szTgtName, MAX_PATH, szIniFile);

	// open FT device
	char szSerial[64];
	lstrcpy(szSerial, p->szSerial);
	FT_HANDLE ftHandle;
	FT_STATUS ftStatus = FT_OpenEx (szSerial, FT_OPEN_BY_SERIAL_NUMBER, &ftHandle);
	if (ftStatus != FT_OK)
	{
		char szBuf[128];
		sprintf_s(szBuf, "%s (error %d)", "FT_GetDeviceInfoList() failed.", ftStatus);
		MessageBox(szBuf, "Error", MB_ICONEXCLAMATION);
		ftHandle = NULL;
	}
	p->nMemSize = nMemSize;
	p->szFileName = szFileName;
	p->szTgtName = szTgtName;
	p->ftHandle = ftHandle;

	HTREEITEM hTreeItem;
	char szBuf[2 * MAX_PATH];
	DeviceConnect(p);
	if (!p->bReady)
		sprintf_s(szBuf, "Device S/N: %s -> NOT READY", szSerial);
	else
		sprintf_s(szBuf, "Device S/N: %s -> READY", szSerial);
	hTreeItem = m_DevTree.InsertItem(TVIF_TEXT | TVIF_PARAM, szBuf, 0, 0, 0, 0, LPARAM(p), NULL, TVI_LAST);
	SetMemSizeLabel(szBuf, MAX_PATH, nMemSize);
	// lParam used as index
	m_DevTree.InsertItem(TVIF_TEXT | TVIF_PARAM, szBuf, 0, 0, 0, 0, 1, hTreeItem, TVI_LAST);
	SetFileNameLabel(szBuf, (2 * MAX_PATH), szFileName);
	m_DevTree.InsertItem(TVIF_TEXT | TVIF_PARAM, szBuf, 0, 0, 0, 0, 2, hTreeItem, TVI_LAST);
	SetTgtNameLabel(szBuf, MAX_PATH, szTgtName);
	m_DevTree.InsertItem(TVIF_TEXT | TVIF_PARAM, szBuf, 0, 0, 0, 0, 3, hTreeItem, TVI_LAST);
	m_DevTree.Expand(hTreeItem, TVE_EXPAND);
	p->hTreeItem = hTreeItem;
	m_dwCount++;

	return TRUE;
}

BOOL CDlg::RemoveDevice(DWORD dwIndex)
{
	TDEVICE *p = m_gpDevice[dwIndex];
	DWORD k;
	FT_HANDLE ftHandle = p->ftHandle;

	for (k = dwIndex + 1; k < m_dwCount; k++)
		m_gpDevice[k - 1] = m_gpDevice[k];
	m_gpDevice[m_dwCount - 1] = NULL;

	HTREEITEM hTreeItem = p->hTreeItem;
	DWORD_PTR pw = m_DevTree.GetItemData(hTreeItem);
	if (pw == (DWORD_PTR(p)))
		m_DevTree.DeleteItem(hTreeItem);

	if (ftHandle != NULL)
		FT_Close(ftHandle);

	m_dwCount--;

	return TRUE;
}


void CDlg::OnRclickDevTree(NMHDR *pNMHDR, LRESULT *pResult)
{
	// TODO: Add your control notification handler code here
	*pResult = 0;
    CPoint ptScreen;
    GetCursorPos(&ptScreen);
	CPoint ptClient(ptScreen);
	m_DevTree.ScreenToClient(&ptClient);
	UINT flags;
	HTREEITEM hTreeItem = m_DevTree.HitTest(ptClient, &flags);
	if (hTreeItem == NULL)
		return; // no item selected
	if (!(TVHT_ONITEM & flags))
		return;
	m_DevTree.SelectItem(hTreeItem);
	HTREEITEM hParent = m_DevTree.GetParentItem(hTreeItem);
	DWORD dwLevel = 0;
	TDEVICE *p;
	if (hParent == NULL)
		p = (TDEVICE*)m_DevTree.GetItemData(hTreeItem);
	else
	{
		p = (TDEVICE*)m_DevTree.GetItemData(hParent);
		dwLevel = (DWORD)m_DevTree.GetItemData(hTreeItem);
	}
	CMenu menu;
	UINT nID;
	switch (dwLevel)
	{
		case 0:
			nID = IDR_MAIN_MENU;
			break;
		case 1:
			nID = IDR_MEMSIZE_MENU;
			break;
		case 2:
			nID = IDR_SELECTFILE_MENU;
			break;
		case 3:
			nID = IDR_TGTNAME_MENU;
			break;
	}
	BOOL b = menu.LoadMenu(nID);
	CMenu *popup = menu.GetSubMenu(0);
	if (dwLevel == 1)
		popup->CheckMenuItem(p->nMemSize + 1, MF_BYCOMMAND | MF_CHECKED);
	else if (dwLevel == 0)
	{
		CString szConnect, szUpload, szDownload;
		szConnect = "Connect to " + p->szSerial;
		szUpload = "Upload File to " + p->szSerial;
		szDownload = "Download File from " + p->szSerial;
		popup->ModifyMenu(ID_CONNECT, MF_BYCOMMAND | MF_STRING, ID_CONNECT, szConnect);
		popup->ModifyMenu(ID_UPLOADFILE, MF_BYCOMMAND | MF_STRING, ID_UPLOADFILE, szUpload);
		popup->ModifyMenu(ID_DOWNLOADFILE, MF_BYCOMMAND | MF_STRING, ID_DOWNLOADFILE, szDownload);

		if (p->bReady)
			popup->EnableMenuItem(ID_CONNECT, MF_BYCOMMAND | MF_GRAYED);
		else
		{
			popup->EnableMenuItem(ID_UPLOADFILE, MF_BYCOMMAND | MF_GRAYED);
			popup->EnableMenuItem(ID_DOWNLOADFILE, MF_BYCOMMAND | MF_GRAYED);
		}
		if (p->szFileName.IsEmpty())
			popup->EnableMenuItem(ID_UPLOADFILE, MF_BYCOMMAND | MF_GRAYED);
	}

	// return nCode = 0 if abort menu
    UINT nCode = popup->TrackPopupMenu(TPM_LEFTALIGN | TPM_RIGHTBUTTON | TPM_RETURNCMD, ptScreen.x, ptScreen.y, this, NULL);
	if (nCode == 0)
		return;
	if (dwLevel == 1)
	{
		// set memory size
		p->nMemSize = nCode - 1;
		char szBuf[128];
		SetMemSizeLabel(szBuf, 128, p->nMemSize);
		m_DevTree.SetItemText(hTreeItem, szBuf);
		UpdateMemSizeIni(p->szSerial, p->nMemSize);
	}
	else if (dwLevel == 2)
	{
		// set file name
		CFileDialog fileDlg(TRUE);
		CString pathName;
		if(fileDlg.DoModal() == IDOK)
		{
			pathName = fileDlg.GetPathName();
			char szBuf[2 * MAX_PATH];
			p->szFileName = pathName;
			SetFileNameLabel(szBuf, (2 * MAX_PATH), pathName);
			m_DevTree.SetItemText(hTreeItem, szBuf);
			UpdateFileNameIni(p->szSerial, pathName);
		}
	}
	else if (dwLevel == 3)
	{
		CTgtDlg dlg;
		dlg.m_strName = p->szTgtName;
		if (dlg.DoModal() == IDOK)
		{
			if (dlg.m_strName.GetLength() > 128)
				dlg.m_strName.Truncate(128);
			p->szTgtName = dlg.m_strName;
			char szBuf[MAX_PATH];
			SetTgtNameLabel(szBuf, MAX_PATH, p->szTgtName);
			m_DevTree.SetItemText(hTreeItem, szBuf);
			UpdateTgtNameIni(p->szSerial, p->szTgtName);
		}
	}
	else
	{
		// main menu
		if (nCode ==  ID_CONNECT)
			DeviceConnect(p);
		else if (nCode == ID_UPLOADFILE)
			UploadFile(p);
		else if (nCode == ID_DOWNLOADFILE)
			DownloadFile(p);
	}
}

void CDlg::SetMemSizeLabel(LPSTR szBuf, UINT nSize, UINT nMemSize)
{
	LPSTR p;

	switch (nMemSize)
	{
		case 0: p = "8K"; break;
		case 1: p = "16K"; break;
		case 2: p = "32K"; break;
		case 3: p = "64K"; break;
		case 4: p = "128K"; break;
		case 5: p = "512K"; break;
		default: p = "512K";
	}
	sprintf_s(szBuf, nSize, "Target Memory Size: %s", p);
}

void CDlg::UpdateMemSizeIni(LPCSTR szSerial, UINT nMemSize)
{
	CApp* pApp = (CApp*)AfxGetApp();
	CString szIniFile = pApp->m_szIniFile;
	// configuration under [serial] section
	if ((nMemSize < 0) || (nMemSize > MAX_MEM_SIZE))
	{
		nMemSize = MAX_MEM_SIZE;
	}
	char buf[64];
	sprintf_s(buf, "%d", nMemSize);
	::WritePrivateProfileString(szSerial, MEM_SIZE_SECT, buf, szIniFile);
}

void CDlg::SetFileNameLabel(LPSTR szBuf, UINT nSize, LPCSTR szPath)
{
	sprintf_s(szBuf, nSize, "Binary File Name: %s", szPath);
}

void CDlg::UpdateFileNameIni(LPCSTR szSerial, LPCSTR szPath)
{
	CApp* pApp = (CApp*)AfxGetApp();
	CString szIniFile = pApp->m_szIniFile;
	// configuration under [serial] section
	::WritePrivateProfileString(szSerial, FILE_NAME_SECT, szPath, szIniFile);
}

void CDlg::SetTgtNameLabel(LPSTR szBuf, UINT nSize, LPCSTR szTgtName)
{
	sprintf_s(szBuf, nSize, "Target Description: %s", szTgtName);
}

void CDlg::UpdateTgtNameIni(LPCSTR szSerial, LPCSTR szTgtName)
{
	CApp* pApp = (CApp*)AfxGetApp();
	CString szIniFile = pApp->m_szIniFile;
	// configuration under [serial] section
	::WritePrivateProfileString(szSerial, TGT_NAME_SECT, szTgtName, szIniFile);
}

// try to connect to the device
BOOL CDlg::DeviceConnect(TDEVICE *pDev)
{
	if (pDev->bReady)
		return TRUE;

	FT_HANDLE ftHandle = pDev->ftHandle;
	CWaitCursor wait;

	if (ftHandle == NULL)
	{
		char szSerial[64];
		lstrcpy(szSerial, pDev->szSerial);
		FT_STATUS ftStatus = FT_OpenEx(szSerial, FT_OPEN_BY_SERIAL_NUMBER, &ftHandle);
		if (ftStatus != FT_OK)
		{
			char szBuf[128];
			sprintf_s(szBuf, "%s (error %d)", "FT_GetDeviceInfoList() failed.", ftStatus);
			MessageBox(szBuf, "Error", MB_ICONEXCLAMATION);
			return FALSE;
		}
		pDev->ftHandle = ftHandle;
	}

	unsigned char txbuf[16];
	//extend timeout while board finishes reset
	FT_SetTimeouts(ftHandle, 300, 300);
	// send first bytes pair
	txbuf[0] = DEV_CONN_BYTE1;
	txbuf[1] = DEV_CONN_BYTE2;
	DWORD dwBytesWritten = 0;
	BOOL b = DeviceWrite(ftHandle, txbuf, 2, dwBytesWritten);
	if (!b)
		return FALSE;
	if (!DeviceAck(ftHandle))
		return FALSE;
	txbuf[0] = DEV_CONN_BYTE3;
	txbuf[1] = DEV_CONN_BYTE4;
	dwBytesWritten = 0;
	b = DeviceWrite(ftHandle, txbuf, 2, dwBytesWritten);
	if (!b)
		return FALSE;
	if (!DeviceAck(ftHandle))
		return FALSE;
	txbuf[0] = DEV_CONN_BYTE5;
	txbuf[1] = DEV_CONN_BYTE6;
	dwBytesWritten = 0;
	b = DeviceWrite(ftHandle, txbuf, 2, dwBytesWritten);
	if (!b)
		return FALSE;
	if (!DeviceAck(ftHandle))
		return FALSE;

	pDev->bReady = TRUE;

	return TRUE;
}

BOOL CDlg::DeviceWrite(FT_HANDLE ftHandle, LPBYTE pBuf, DWORD dwBytesToWrite, DWORD& dwBytesWritten)
{
	DWORD dwRes = 0;
	FT_STATUS ftStatus = FT_Write(ftHandle, (LPVOID)pBuf, dwBytesToWrite, &dwRes);
	if (ftStatus != FT_OK)
	{
		char szBuf[128];
		sprintf_s(szBuf, "%s (error %d)", "FT_Write() failed.", ftStatus);
		MessageBox(szBuf, "Error", MB_ICONEXCLAMATION);
		dwBytesWritten = 0;
		return FALSE;
	}
	dwBytesWritten = dwRes;
	if (dwRes != dwBytesToWrite)
	{
		char szBuf[512];
		sprintf_s(szBuf, "%s: written %d bytes instead of %d", "FT_Write() failed", dwRes, dwBytesToWrite);
		MessageBox(szBuf, "Error", MB_ICONEXCLAMATION);
		return FALSE;
	}

	return TRUE;
}

BOOL CDlg::DeviceRead(TDEVICE* pDev, LPBYTE pBuf, DWORD dwBytesToRead)
{
	DWORD dwRes = 0, dwRes2, dwSize = 0;
	LPBYTE p = pBuf;
	FT_HANDLE ftHandle = pDev->ftHandle;

	ZeroMemory(p, dwBytesToRead);

	// 5 secs. RX timeout
	FT_STATUS ftStatus = FT_SetTimeouts(ftHandle, 5000, 300);
	if (ftStatus != FT_OK)
	{
		char szBuf[512];
		sprintf_s(szBuf, "%s (error %d)", "FT_SetTimeouts() failed.", ftStatus);
		MessageBox(szBuf, "Error", MB_ICONEXCLAMATION);
		return FALSE;
	}

	DWORD dwSizeKb =  dwBytesToRead / 1024;
	char szBuf[512];
	sprintf_s(szBuf, "RECEIVE %dKb FROM DEVICE %s", dwSizeKb, pDev->szSerial);
	TransferDlg(szBuf);
	dwRes = 0;
	while (dwSize < dwBytesToRead)
	{
		ftStatus = FT_GetQueueStatus(ftHandle, &dwRes);
		if (ftStatus != FT_OK)
		{
			char szBuf[512];
			m_pTransfer->DestroyWindow();
			sprintf_s(szBuf, "%s (error %d)", "FT_GetQueueStatus() failed.", ftStatus);
			MessageBox(szBuf, "Error", MB_ICONEXCLAMATION);
			return FALSE;
		}
		if (dwRes > 0)
		{
			dwRes2 = 0;
			ftStatus = FT_Read(ftHandle, (LPVOID)p, dwRes, &dwRes2);
			if ((ftStatus != FT_OK) || (dwRes2 != dwRes))
			{
				char szBuf[512];
				m_pTransfer->DestroyWindow();
				sprintf_s(szBuf, "%s (error %d)", "FT_Read() failed.", ftStatus);
				MessageBox(szBuf, "Error", MB_ICONEXCLAMATION);
				return FALSE;
			}
			p+= dwRes;
			dwSize += dwRes;
		}
	}

	m_pTransfer->DestroyWindow();

	if (dwSize != dwBytesToRead)
	{
		char szBuf[512];
		sprintf_s(szBuf, "%s: received %d bytes instead of %d", "FT_Read() failed", dwSize, dwBytesToRead);
		MessageBox(szBuf, "Error", MB_ICONEXCLAMATION);
		return FALSE;
	}

	return TRUE;
}

BOOL CDlg::DeviceAck(FT_HANDLE ftHandle)
{
	unsigned char Buf[16];
	DWORD dwRes = 0;

	FT_STATUS ftStatus = FT_Read(ftHandle, (LPVOID)Buf, 1, &dwRes);
	if ((dwRes == 1) && (Buf[0] == DEVICE_ACK))
		return TRUE;

	return FALSE;
}

DWORD CDlg::GetMemSize(TDEVICE *pDev)
{
	DWORD dwSize;

	switch (pDev->nMemSize)
	{
		case 0: dwSize = 8; break;
		case 1: dwSize = 16; break;
		case 2: dwSize = 32; break;
		case 3: dwSize = 64; break;
		case 4: dwSize = 128; break;
		case 5: dwSize = 512; break;
		default: dwSize = 512;
	}
	dwSize *= (1024);

	return dwSize;
}

BOOL CDlg::SendCommand(FT_HANDLE ftHandle, BOOL bUpload, BYTE nPages, BYTE nBlk)
{
	BYTE txbuf[8];
	DWORD dwRes;

	if (bUpload)
	{
		txbuf[0] = DEV_UPLOAD1;
		txbuf[1] = DEV_UPLOAD2;
	}
	else
	{
		txbuf[0] = DEV_DOWNLOAD1;
		txbuf[1] = DEV_DOWNLOAD2;
	}
	txbuf[2] = nPages;
	txbuf[3] = nBlk;
	BOOL b = DeviceWrite(ftHandle, txbuf, 4, dwRes);
	if (!b)
		return FALSE;
	if (!DeviceAck(ftHandle))
		return FALSE;
	return TRUE;
}

void CDlg::UploadFile(TDEVICE *pDev)
{
	DWORD dwSize = GetMemSize(pDev);
	CFile f;
	CFileException ex;
	PBYTE pTxBuf = NULL, pRxBuf = NULL, p;
	BYTE nBlk, nPages;

	if (pDev->nMemSize == (ID_MEMORYSIZE_512K - 1))
		nBlk = 8;
	else if (pDev->nMemSize == (ID_MEMORYSIZE_128K - 1))
		nBlk = 2;
	else
		nBlk = 1;

	switch (pDev->nMemSize)
	{
		case 0: nPages = 32; break;
		case 1: nPages = 64; break;
		case 2: nPages = 128; break;
		default: nPages = 0;
	}

	if (!f.Open(pDev->szFileName, CFile::modeRead, &ex))
	{
		// complain if an error happened 
		// no need to delete the ex object
		char szError[1024], szMsg[2048];
		ex.GetErrorMessage(szError, 1024);
		sprintf_s(szMsg, "Couldn't open source file: %s", szError);
		MessageBox(szMsg, "Error", MB_ICONEXCLAMATION);
		return;
	}
	DWORD dwFSize = (DWORD)f.GetLength();
	if (dwFSize < dwSize)
	{
		char szMsg[1024];
		sprintf_s(szMsg, "Source file %s size (%d) unmatch selected memory size (%d)", pDev->szFileName, dwFSize, dwSize);
		MessageBox(szMsg, "Error", MB_ICONEXCLAMATION);
		return;
	}

	dwFSize = dwSize + 256;
	pTxBuf = new BYTE[dwFSize];
	pRxBuf = new BYTE[dwFSize];
	f.Read(pTxBuf, dwSize);
	f.Close();
	// upload command
	FT_Purge(pDev->ftHandle, FT_PURGE_RX | FT_PURGE_TX);
	FT_SetTimeouts(pDev->ftHandle, 300, 300);
	BOOL b = SendCommand(pDev->ftHandle, TRUE, nPages, nBlk);
	if (!b)
	{
		char szMsg[1024];
		sprintf_s(szMsg, "Upload command to %s failed", pDev->szSerial);
		MessageBox(szMsg, "Error", MB_ICONEXCLAMATION);
		goto end;
	}

	DWORD dwSizeKb =  dwSize / 1024;
	char szBuf[512];
	sprintf_s(szBuf, "TRANSFER %dKb TO DEVICE %s", dwSizeKb, pDev->szSerial);
	TransferDlg(szBuf);

	p = pTxBuf;
	// TX loop
	DWORD dwBlkSize = dwSize, dwRes;
	if (nBlk > 1)
		dwBlkSize = 0x10000; // 64K

	while (nBlk > 0)
	{
		// 2 secs. TX timeout
		FT_SetTimeouts(pDev->ftHandle, 300, 2000);
		dwRes = 0;
		b = DeviceWrite(pDev->ftHandle, p, dwBlkSize, dwRes);
		if (!b)
		{
			char szMsg[1024];
			m_pTransfer->DestroyWindow();
			sprintf_s(szMsg, "Upload command to %s aborted", pDev->szSerial);
			MessageBox(szMsg, "Error", MB_ICONEXCLAMATION);
			goto end;
		}
		p += dwRes;
		Sleep(1);
		nBlk--;
	}
	m_pTransfer->DestroyWindow();
	if (!DeviceAck(pDev->ftHandle))
	{
		char szMsg[1024];
		sprintf_s(szMsg, "Upload command to %s failed", pDev->szSerial);
		MessageBox(szMsg, "Error", MB_ICONEXCLAMATION);
		goto end;
	}

	if (!DeviceRead(pDev, pRxBuf, dwSize))
		goto end;

	if (memcmp(pTxBuf, pRxBuf, dwSize) != 0)
	{
		char szMsg[1024];
		sprintf_s(szMsg, "Upload command to %s: data unmatch", pDev->szSerial);
		MessageBox(szMsg, "Error", MB_ICONEXCLAMATION);
	}

end:
	if (pTxBuf != NULL)
		delete[] pTxBuf;
	if (pRxBuf != NULL)
		delete[] pRxBuf;
}

void CDlg::DownloadFile(TDEVICE *pDev)
{
	DWORD dwSize = GetMemSize(pDev);
	CFile f;
	CFileException ex;
	PBYTE pRxBuf = NULL;
	BYTE nBlk, nPages;

	if (pDev->nMemSize == (ID_MEMORYSIZE_512K - 1))
		nBlk = 8;
	else if (pDev->nMemSize == (ID_MEMORYSIZE_128K - 1))
		nBlk = 2;
	else
		nBlk = 1;

	switch (pDev->nMemSize)
	{
		case 0: nPages = 32; break;
		case 1: nPages = 64; break;
		case 2: nPages = 128; break;
		default: nPages = 0;
	}

	pRxBuf = new BYTE[dwSize + 256];
	// set file name to save
	CFileDialog fileDlg(FALSE);
	CString pathName;
	if(fileDlg.DoModal() == IDOK)
	{
			pathName = fileDlg.GetPathName();
	}
	else
		return;

	if (!f.Open(pathName, CFile::modeWrite | CFile::modeCreate, &ex))
	{
		// complain if an error happened 
		// no need to delete the ex object
		char szError[1024], szMsg[2048];
		ex.GetErrorMessage(szError, 1024);
		sprintf_s(szMsg, "Couldn't open file: %s", szError);
		MessageBox(szMsg, "Error", MB_ICONEXCLAMATION);
		goto end;
	}

	// download command
	FT_Purge(pDev->ftHandle, FT_PURGE_RX | FT_PURGE_TX);
	FT_SetTimeouts(pDev->ftHandle, 300, 300);
	BOOL b = SendCommand(pDev->ftHandle, FALSE, nPages, nBlk);
	if (!b)
	{
		char szMsg[1024];
		sprintf_s(szMsg, "Download command from %s failed", pDev->szSerial);
		MessageBox(szMsg, "Error", MB_ICONEXCLAMATION);
		goto end;
	}

	if (DeviceRead(pDev, pRxBuf, dwSize))
	{
		f.Write(pRxBuf, dwSize);
	}

end:
	f.Close();
	if (pRxBuf != NULL)
		delete[] pRxBuf;
}

void CDlg::TransferDlg(LPCSTR szText)
{
	if (m_pTransfer == NULL)
	{
		m_pTransfer = new CTransfer(this);
		m_pTransfer->m_strText = szText;
		if (m_pTransfer->Create(IDD_TRANSFER, this))
		{
			m_pTransfer->ShowWindow(SW_SHOW);
		}
		else
		{
			delete m_pTransfer;
			m_pTransfer = NULL;
		}
	}
}
